
/* This handles the initialization of the client.  This includes making
 * the I_IMAGE and I_ARCH commands.
 */

#include <client.h>


/*
 * A replacement of strdup(), since it's not defined at some
 * unix variants.
 */

char *strdup_local(char *str) {
  char *c=(char *)malloc(sizeof(char)*strlen(str)+1);
  strcpy(c,str);
  return c;
}


void VersionCmd(char *data, int len)
{
    int version=atoi(data);

    if (ECLIENT_VERSION != version) {
	fprintf(stderr,"Client, Server have different versions (%d,%d)\n",
	   ECLIENT_VERSION,version);
	exit(1);
    }
}

void SendVersion(ClientSocket csock)
{
    char buf[MAX_BUF];

    sprintf(buf,"version %d", ECLIENT_VERSION);
    cs_write_string(csock.fd, buf, strlen(buf));
}


void SendAddMe(ClientSocket csock)
{

    cs_write_string(csock.fd, "addme",7);
}


void SendSetFaceMode(ClientSocket csock,int mode)
{
    char buf[MAX_BUF];

    sprintf(buf,"setfacemode %d", mode);
    cs_write_string(csock.fd, buf, strlen(buf));
}


void init_client_vars()
{
    int i;


    /* I think environemental variables should be more important than
     * compiled in defaults, so these probably should be reversed. 
     */
    client_libdir=getenv("CFCLIENT_LIBDIR");
#ifdef CLIENT_LIBDIR
    if (client_libdir==NULL)
	client_libdir=CLIENT_LIBDIR;
#endif
    client_archfile = getenv("CFCLIENT_ARCHFILE");
#ifdef CLIENT_ARCHFILE
    if (client_archfile==NULL)
	client_archfile=CLIENT_ARCHFILE;
#endif

    cpl.count_left = 0;
    cpl.container = NULL;
    cpl.show_what = 0;
    memset(&cpl.stats,0, sizeof(Stats));
    cpl.stats.maxsp=1;	/* avoid div by 0 errors */
    cpl.stats.maxhp=1;	/* ditto */
    cpl.stats.maxgrace=1;	/* ditto */
    /* ditto - displayed weapon speed is weapon speed/speed */
    cpl.stats.speed=1;
    cpl.input_text[0]='\0';
    cpl.title[0] = '\0';
    cpl.range[0] = '\0';

    for (i=0; i<range_size; i++)
	cpl.ranges[i]=NULL;

    cpl.map_x=0;
    cpl.map_y=0;

    cpl.ob = player_item();
    cpl.below = map_item();
    cpl.magicmap=NULL;
    cpl.showmagic=0;
}
